package net.knarcraft.minecraftserverlauncher.server.servertypes;

import java.io.File;
import java.nio.file.Paths;

import static net.knarcraft.minecraftserverlauncher.utility.CommonFunctions.downloadFile;

public class CraftBukkit extends AbstractServerType {

    private String downloadURLPart;

    /**
     * Instantiates a new server type
     *
     * @param typeName    <p>The name of the server type</p>
     * @param versions    <p>A list of one or more server versions for the type</p>
     * @param downloadURL <p>The URL used for downloading .jar files</p>
     * @param downloadURLPart <p>A string used after the download url as an additional part of the URL</p>
     */
    public CraftBukkit(String typeName, String[] versions, String downloadURL, String downloadURLPart) {
        super(typeName, versions, downloadURL);
        this.downloadURLPart = downloadURLPart;
    }

    @Override
    public boolean downloadJar(String folder, String version) {
        String targetFile = this.getName() + version + ".jar";
        String file = downloadURLPart + version + ".jar";
        File filePath = new File(folder + targetFile);
        return filePath.isFile() || downloadFile(downloadURL + file, Paths.get(filePath.toURI()));
    }

}
