package net.knarcraft.minecraftserverlauncher.userinterface;

/**
 * Describes a generic GUI
 */
public interface GUI {

    /**
     * Displays a message to the user in the GUI message field
     *
     * @param message <p>The message contents</p>
     */
    void setStatus(String message);

    /**
     * Displays an error to the user as an independent box
     *
     * @param title <p>The title of the error message</p>
     * @param message <p>The error message contents</p>
     */
    void showError(String title, String message);

    /**
     * Displays an error to the user as an independent box
     *
     * @param message <p>The error message contents</p>
     */
    void showError(String message);

    /**
     * Displays a message to the user as an independent box
     *
     * @param title <p>The title of the message</p>
     * @param message <p>The message contents</p>
     */
    void showMessage(String title, String message);

    /**
     * Displays a message to the user as an independent box
     *
     * @param message <p>The message contents</p>
     */
    void showMessage(String message);

}
